%     VIRTUAL LAMINATE - программа для получения эффективных свойств слоистых пластин
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Stacking = Read_Stacking()

global ErrCode;

Stacking = [];

fprintf (1, 'Чтение укладки...                                       ');

% Открытие файла
File_Path = '_Stacking_Sequence.txt';
Fin = fopen(File_Path, 'r');

if (Fin < 0)
    fprintf (1, '\nОшибка функции Read_Stacking: не удалось открыть файл %s !\n', File_Path);
    ErrCode = -1;
    return;
end

% Чтение файла
Stacking = zeros(10000,3);

counter = 0;

while (~feof(Fin))
    
    string = strtrim(fgets(Fin));
    
    if (isempty(string))
        continue;
    end
    
    if (string(1) == '#')
        continue;
    end
    
    temp_cell_array = strsplit(string, {' ', '\t'});
    
    if (isempty(temp_cell_array{1}) || isempty(temp_cell_array{size(temp_cell_array,2)}))
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    if (size(temp_cell_array, 2) ~= 3)
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    counter = counter + 1;
    
    [tmp, count] = sscanf(temp_cell_array{1}, '%i');
    
    if (count == 1)
        Stacking(counter,1) = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    [tmp, count] = sscanf(temp_cell_array{2}, '%e');
    
    if (count == 1)
        Stacking(counter,2) = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    [tmp, count] = sscanf(temp_cell_array{3}, '%i');
    
    if (count == 1)
        Stacking(counter,3) = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
end

% Финализация
if (counter == 0)
    Stacking = [];
else
    Stacking = Stacking(1:counter,:);
end

% Закрытие файла
fclose(Fin);

% Проверка
if (counter == 0)
    fprintf (1, '\nОшибка: пустой файл %s !\n', File_Path);
    ErrCode = -1;
    return;
end

fprintf (1, 'OK!\n');
